/*
 * ball.hpp - XD-Ball
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef BALL_HPP_INCLUDED
#define BALL_HPP_INCLUDED

#include "sprite.hpp"
#include "updatable.hpp"

#include "brick.hpp"
#include "paddle.hpp"

class Ball: public Sprite, public Updatable
{
public:
	
	struct Collision
	{
		bool happened;
		sf::Vector2f position;
		sf::Vector2f speed;
	};
	
	
	Ball(const sf::Vector2f&, const sf::Vector2f&, const sf::Vector2f&);
	
	sf::Vector2f speed;
	
	virtual void update(float);
	
	Collision collide(const Brick*);
	Collision collide(const Paddle*);
	
	virtual ~Ball();
};

#endif // BALL_HPP_INCLUDED
