/*
 * guistring.hpp - Kukatz 3D
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *	 1. The origin of this software must not be misrepresented; you must not
 *			claim that you wrote the original software. If you use this software
 *			in a product, an acknowledgment in the product documentation would be
 *			appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *			misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *			distribution.
 */

#ifndef GUISTRING_HPP_INCLUDED
#define GUISTRING_HPP_INCLUDED

#include <string>

#include <SFML/System/Unicode.hpp>

#include "string.hpp"
#include "guielement.hpp"

class GUIString: public String, public GUIElement
{
public:
	GUIString(const sf::Unicode::Text&, const std::string&, float);
	GUIString(const sf::Unicode::Text&, const std::string&);
	
	virtual void set_text(const sf::Unicode::Text&);
	
	virtual void render();
	
	virtual ~GUIString();
};

#endif // GUISTRING_HPP_INCLUDED
