/*
 * mainmenu.hpp - Kukatz 3D
 * Copyright (c) 2010, 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *	 1. The origin of this software must not be misrepresented; you must not
 *			claim that you wrote the original software. If you use this software
 *			in a product, an acknowledgment in the product documentation would be
 *			appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *			misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *			distribution.
 */

#ifndef MAINMENU_HPP_INCLUDED
#define MAINMENU_HPP_INCLUDED

#include <vector>

#include "opengl.hpp"

#include <SFML/Window/Event.hpp>
#include <SFML/Graphics/String.hpp>
#include <SFML/System/Clock.hpp>
#include <SFML/Audio/Music.hpp>

#include "statebase.hpp"
#include "guielementcontainer.hpp"
#include "guistring.hpp"
#include "background.hpp"

class MainMenu: public StateBase
{
private:
	Background background;
	GUIElementContainer gui;
	sf::Music music;
	
	GUIString* title;
	
	unsigned int current_item;
	std::vector< GUIString* > items;
	
	float time;
	
public:
	MainMenu(unsigned int, unsigned int);
	
	void resize(const sf::Vector2i&);
	
	virtual void process_events(std::vector< sf::Event >&);
	virtual void update(float);
	void render();
	
	virtual ~MainMenu();
};

#endif//MAINMENU_HPP_INCLUDED
