/*
 * scoremanager.hpp - Kukatz 3D
 * Copyright (c) 2012 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *   2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *   3. This notice may not be removed or altered from any source
 *      distribution.
 */

#ifndef SCOREMANAGER_HPP_INCLUDED
#define SCOREMANAGER_HPP_INCLUDED

#include "singleton.hpp"

#include <vector>

#include <SFML/System/Unicode.hpp>

class ScoreManager: public Singleton< ScoreManager >
{
private:
	std::vector< std::pair< sf::Unicode::Text, sf::Uint32 > > scores;
	
public:
	ScoreManager();
	
	bool submit(const sf::Unicode::Text&, sf::Uint32);
	const std::vector< std::pair< sf::Unicode::Text, sf::Uint32 > >& get_scores() const; // RESPECT Z FOR THE CONST!
	
	void save();
	
	virtual ~ScoreManager();
};

#endif // SCOREMANAGER_HPP_INCLUDED
