/*
 * statebase.hpp - Kukatz 3D
 * Copyright (c) 2010, 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *	 1. The origin of this software must not be misrepresented; you must not
 *			claim that you wrote the original software. If you use this software
 *			in a product, an acknowledgment in the product documentation would be
 *			appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *			misrepresented as being the original software.
 * 
 *	 3. This notice may not be removed or altered from any source
 *			distribution.
 */

#ifndef STATEBASE_HPP_INCLUDED
#define STATEBASE_HPP_INCLUDED

#include <vector>

#include <SFML/Window/Event.hpp>
#include <SFML/System/Vector2.hpp>

#include "updatable.hpp"
#include "eventhandler.hpp"
#include "renderable.hpp"

// base class for all gamestates
class StateBase: public Updatable, public EventHandler, public Renderable
{
private:
	bool will_pop;
	
protected:
	StateBase(unsigned int, unsigned int);
	
	sf::Vector2i size;
	void pop();
	
public:
	virtual void resize(const sf::Vector2i&) = 0;
	
	const bool &should_pop();
	
	virtual ~StateBase();
};

#endif //STATEBASE_HPP_INCLUDED
