/*
 * background.cpp - XD-Ball
 * Copyright (c) 2011 - TÖRÖK Attila (torokati44@gmail.com)
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *   1. The origin of this software must not be misrepresented; you must not
 *      claim that you wrote the original software. If you use this software
 *      in a product, an acknowledgment in the product documentation would be
 *      appreciated but is not required.
 *
 *	 2. Altered source versions must be plainly marked as such, and must not be
 *      misrepresented as being the original software.
 *
 *	 3. This notice may not be removed or altered from any source
 *      distribution.
 */

#include "background.hpp"

#include <cmath>

#include <SFML/System/Randomizer.hpp>

Background::Background():
	Sprite(((sf::Randomizer::Random(0, 1) == 1)?("BACKGROUND1"):("BACKGROUND2")), sf::Vector2f(400, 300)),
	time(sf::Randomizer::Random(-10000.0f, 10000.0f))
{
	size *= 10.0f;
	origin *= 10.0f;
	
	color = sf::Color(0, 0, 0, 255);
}

void Background::update(float dt)
{
	time += dt;
	
	color.r = ((cos(time / 3.0f) + 1.0f) * 32.0f) + 32;
	color.g = ((sin(time / 5.0f) + 1.0f) * 32.0f) + 32;
	color.b = ((sin(time / 7.0f) + 1.0f) * 32.0f) + 32;
}

void Background::render()
{
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(5 + sin(time * 0.17f) * 2, 5 + sin(time * 0.06f) * 2, 0);
	glRotatef(sin(time * 0.02f) * 180, 0, 0, 1);
	glTranslatef(-5 + cos(time * 0.11f) * 2, -5 + sin(time * 0.21f) * 2, 0);
	glScalef(10 + sin(time * 0.07) * 4, 10 + sin(time * 0.07) * 4, 0);
	glMatrixMode(GL_MODELVIEW);
	Sprite::render();
	glMatrixMode(GL_TEXTURE);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

Background::~Background()
{
	
}
